#ifndef __HRN_SIDEBAR_ITEM_FACTORY_H__
#define __HRN_SIDEBAR_ITEM_FACTORY_H__

#include <glib-object.h>

#include "hrn-pin-manager.h"

G_BEGIN_DECLS

#define HRN_TYPE_SIDEBAR_ITEM_FACTORY                                   \
   (hrn_sidebar_item_factory_get_type())
#define HRN_SIDEBAR_ITEM_FACTORY(obj)                                   \
   (G_TYPE_CHECK_INSTANCE_CAST ((obj),                                  \
                                HRN_TYPE_SIDEBAR_ITEM_FACTORY,          \
                                HrnSidebarItemFactory))
#define HRN_SIDEBAR_ITEM_FACTORY_CLASS(klass)                           \
   (G_TYPE_CHECK_CLASS_CAST ((klass),                                   \
                             HRN_TYPE_SIDEBAR_ITEM_FACTORY,             \
                             HrnSidebarItemFactoryClass))
#define IS_HRN_SIDEBAR_ITEM_FACTORY(obj)                                \
   (G_TYPE_CHECK_INSTANCE_TYPE ((obj),                                  \
                                HRN_TYPE_SIDEBAR_ITEM_FACTORY))
#define IS_HRN_SIDEBAR_ITEM_FACTORY_CLASS(klass)                        \
   (G_TYPE_CHECK_CLASS_TYPE ((klass),                                   \
                             HRN_TYPE_SIDEBAR_ITEM_FACTORY))
#define HRN_SIDEBAR_ITEM_FACTORY_GET_CLASS(obj)                         \
   (G_TYPE_INSTANCE_GET_CLASS ((obj),                                   \
                               HRN_TYPE_SIDEBAR_ITEM_FACTORY,           \
                               HrnSidebarItemFactoryClass))

typedef struct _HrnSidebarItemFactoryPrivate HrnSidebarItemFactoryPrivate;
typedef struct _HrnSidebarItemFactory      HrnSidebarItemFactory;
typedef struct _HrnSidebarItemFactoryClass HrnSidebarItemFactoryClass;

struct _HrnSidebarItemFactory
{
    GObject parent;

    HrnSidebarItemFactoryPrivate *priv;
};

struct _HrnSidebarItemFactoryClass
{
    GObjectClass parent_class;
};

GType hrn_sidebar_item_factory_get_type (void) G_GNUC_CONST;
HrnSidebarItemFactory *hrn_sidebar_item_factory_new (HrnSidebar    *sidebar,
                                                     HrnPinManager *pin_manager);

G_END_DECLS

#endif /* __HRN_SIDEBAR_ITEM_FACTORY_H__ */
